//Andr Mouhot
var NSAM6Img=NSAM6Img||{};
NSAM6Img.g_DessineStrict=true;
NSAM6Img.g_b2Trace=false;
NSAM6Img.num=-1;

NSAM6Img.JardinImg=function(divCanvaId,docElemId,imageSrc,numObj,x,y,e,bStatic,txtBouton)
{
  try{
	this.a90=this.EnRadian(90);
	this.a180=this.EnRadian(180);
	this.a270=this.EnRadian(270);
	this.a360=this.EnRadian(360);
	this.ErrMsg="";
	this.canvasId="";
	this.num=0;
	this.cmd="";
	this.echelleDessin=1;
	this.echelleImg=e;
	this.lastAngle=0;
	this.zOrder=2;
	this.x=this.y=0;
	this.dx=this.dy=0;
	this.row=this.col=this.plan=0;
	this.bredraw=false;
	this.bmousedown=false;
	this.isStatic=false;
	this.lock=false;
	this.pSuiv=null;
	this.lastmousePos=null;
	this.mousePos=null;
	if(numObj) this.num=numObj; 
	this.canvas=null;
	this.context=null;
	this.imageSrcExt="";
	if(bStatic) this.isStatic=true;
	this.parentId=divCanvaId;
	this.nodeId=docElemId;
	if (txtBouton) this.txtBouton=txtBouton; else this.txtBouton="?";
	var node=document.getElementById(docElemId);
	//if(numObj>200) return null;
	if(node && !document.getElementById('img'+numObj)){//('img0')){
		var nextCanvas=document.createElement("canvas");
	    var att = document.createAttribute("draggable");
	    att.value = "true";
	    nextCanvas.setAttributeNode(att);
		
		nextCanvas.id='img'+numObj;
		nextCanvas.style.position="absolute";
		nextCanvas.style.zIndex=2;
	
   		node.appendChild(nextCanvas);
   		/*
		var scanva;
		for(var i=0;i<200;i++){
			scanva="<canvas class='cimg' id='img"+i+"'style='position:absolute;z-Index:2;'></canvas><br>";
			node.innerHTML+=scanva;
		}
		*/
	}
	this.canvas=document.getElementById('img'+numObj);
    if(this.canvas)
	{
		// numObj ?
		this.context=this.canvas.getContext('2d');
		this.imageSrc=imageSrc;
		var pMe=this;
		this.image=new Image();
		this.image.onload=function()
		{
			pMe.imgNum=this.width;
			pMe.imgWidth=this.width;
			pMe.imgHeight=this.height;
			pMe.canvas.width=this.width;
			pMe.canvas.height=this.height;
			//alert("pMe.imgWidth on create"+pMe.imgWidth);
			pMe.dessine(pMe.lastAngle,pMe.echelleImg,pMe.image.src);
			if(x!=null && y!=null)
				{pMe.x=x;pMe.y=y;pMe.moveTo(x,y);}
			if(!pMe.isStatic) pMe.resize();
		};

		this.image.src=imageSrc;
		//this.canvas.style.zIndex=1;
		//	this.lock=true;
	}
  }catch(e){this.ErrMsg="Err: "+e.message;alert(this.ErrMsg);}
};

//Proprits
/*
NSAM6Img.JardinImg.canvas=null;
NSAM6Img.JardinImg.canvasId="";
NSAM6Img.JardinImg.context=null;
NSAM6Img.JardinImg.image=null;
NSAM6Img.JardinImg.a90=0;
NSAM6Img.JardinImg.a180=0;
NSAM6Img.JardinImg.a270=0;
NSAM6Img.JardinImg.a360=0;
NSAM6Img.JardinImg.row=0;
NSAM6Img.JardinImg.col=0;
NSAM6Img.JardinImg.plan=0;
NSAM6Img.JardinImg.x=0;
NSAM6Img.JardinImg.y=0;
NSAM6Img.JardinImg.cx=0;
NSAM6Img.JardinImg.cy=0;
NSAM6Img.JardinImg.dx=0;
NSAM6Img.JardinImg.dy=0;
NSAM6Img.JardinImg.zOrder=1;
NSAM6Img.JardinImg.cmd="";
NSAM6Img.JardinImg.imageSrc="";
NSAM6Img.JardinImg.imageSrcExt="";
NSAM6Img.JardinImg.imgWidth=0;
NSAM6Img.JardinImg.imgHeight=0;
NSAM6Img.JardinImg.echelleImg=1;
NSAM6Img.JardinImg.lastAngle=0;
NSAM6Img.JardinImg.ErrMsg="";
NSAM6Img.JardinImg.angleReel=0;
NSAM6Img.JardinImg.num=0;
NSAM6Img.JardinImg.echelleDessin=1;
NSAM6Img.JardinImg.mousePos=null;
NSAM6Img.JardinImg.bredraw=false;
NSAM6Img.JardinImg.lock=false;
NSAM6Img.JardinImg.isStatic=false;
NSAM6Img.JardinImg.pSuiv=null;
*/
//________________
//Mthodes

NSAM6Img.JardinImg.prototype.EnRadian=function(d){return d*(Math.PI/180);};
NSAM6Img.JardinImg.prototype.EnDegre=function(r){return r*(180/Math.PI);};
//!Srialization
NSAM6Img.JardinImg.prototype.ToString=function(){return this.dump;}
NSAM6Img.JardinImg.prototype.dump=function()
{
	/*var sDump="";
	for(pthis=this;pthis;pthis=pthis.pSuiv)
	{
		if(pthis.num && pthis.canvas)
			if(pthis.canvas.width>0)
			{
				//pthis.ToCell();
				sDump+="n:"+pthis.num+"/e:"+pthis.echelleImg+"/a:"+pthis.lastAngle+"/z:"+pthis.zOrder;
				sDump+="/r:"+pthis.row+"/c:"+pthis.col+"/p:"+pthis.plan;
				sDump+="/x:"+pthis.dx+"/y:"+pthis.dy;
				if(pthis.imageSrcExt.length>0)
				{
				 sDump+="/i:"+pthis.imageSrcExt;
				}
				sDump+="/m:"+pthis.cmd;
				sDump+=";";
			}
	}
	if(sDump.length>0) 
	{
		var elemName=document.getElementById("inputReseau");
		document.getElementById("infoMouse").innerHTML="";
		if(elemName)
			if(elemName.value.length)
			{
				divGraph.resName=elemName.value;
				document.getElementById("infoMouse").innerHTML="Enregistrement "+" en cours...";
				JaoDispatch.reqPut(JaoDispatch.dispatchEvent,"SetReseau.cgi",sDump,"dumpSign");
				return true;
			}
	}*/
	return false;
};
//!Deserialisation partielle ou totale
NSAM6Img.JardinImg.prototype.load=function(bFull)
{
};
//!Methode pour positionner et orienter une image
NSAM6Img.JardinImg.prototype.dessine=function(angle,echelle,imageSrc,PosX,PosY)
{
	if(!this.canvas) return false;
	this.ErrMsg="";
	//prchargement image
	//if(!this.imgWidth)
		if(!this.imgWidth && this.image.complete)
		{
			this.imgWidth=this.image.width;
			this.imgHeight=this.image.height;
			this.canvas.width=this.image.width;
			this.canvas.height=this.image.height;
//alert("this.imgWidth on dessine"+this.imgWidth);
			return false;
		}
		//else if(!this.image.complete)
		//	return false;
	//====================
	try{
	this.ready=false;

	if(angle===null) angle=this.lastAngle;
	
	var angleReel=this.angleReel,
		angleInitial=angle,
		cx=this.cx,cy=this.cy,
		alpha=angle;
	
	if(echelle===null) echelle=this.echelleImg;//if(!echelle) echelle=1;
	else if(echelle===0) echelle=1;
	
	if(angle===null) 
		{angle=this.lastAngle;alert("this.lastAngle "+angle);}
	
	if(imageSrc===null) imageSrc=this.imageSrc;//this.image.src;
    else this.imageSrc=imageSrc;

    //context.beginPath();
	if(angle>=0 && angle<=360)
	//if(angle!=this.lastAngle  || echelle!=this.echelleImg || this.image.src!=imageSrc || this.bredraw)
	{
		//this.canvas.width=Math.floor((echelle*this.echelleDessin)*this.imgWidth);
		//this.canvas.height=Math.floor((echelle*this.echelleDessin)*this.imgHeight);
		angleReel=this.EnRadian(angle);
		cx=0;cy=0;
		//if(!angle) angle=this.lastAngle;
		//if(!imageSrc) imageSrc=this.image.src;
		
		this.lastAngle=angle;
		this.echelleImg=echelle;
		
		if(imageSrc!=this.image.src && !this.imageSrcExt.length)
		{
			//if(this.imageSrcExt.length)
			//	this.image.src=this.imageSrcExt; 
			var pMe=this;
			delete this.image;
			this.image=new Image();
			this.imgWidth=0;
			this.bredraw=true;
			this.image.onload=function()
			{
				if(!pMe.imgWidth)//incomphensible cette affaire
				{
				pMe.imgWidth=this.width;
				pMe.imgHeight=this.height;
				pMe.canvas.width=this.width;
				pMe.canvas.height=this.height;
				pMe.dessine(pMe.lastAngle,pMe.echelleImg,pMe.image.src,pMe.x,pMe.y);
				if(PosX!=null && PosY!=null)
					{pMe.x=PosX;pMe.y=PosY;pMe.moveTo(PosX,PosY);}
				if(!pMe.isStatic) 
					pMe.resize();
//alert("pMe.imgWidth on dessine onload "+pMe.imgWidth);
				}
				pMe.bredraw=false;

			};
			this.image.src=imageSrc;
			return true;
		}
//alert("on dessine "+imageSrc);
				
		this.image.width=this.canvas.width=Math.floor((echelle*this.echelleDessin)*this.imgWidth);
		this.image.height=this.canvas.height=Math.floor((echelle*this.echelleDessin)*this.imgHeight);

		if(this.image.height<5 || this.image.height<5) this.image.width=this.image.height=this.canvas.width=this.canvas.height=5;
		this.echelleImg=echelle;
		this.lastAngle=angle;
		angle=this.EnRadian(angle);
		alpha=angle;
		if(angle>0 && ( angle<=this.a90 || angle>=this.a270))
		{
			if (angle>=this.a270) alpha=this.a360-angle;
			var BC=this.image.height;
			var AB=this.image.width;
			var OH=BC/2;
			var AH=AB/2;
			var OA=Math.sqrt(Math.pow(OH,2)+Math.pow(AH,2));
			var AOJ=this.a90-alpha-(Math.acos(OH/OA));
			var BAAp=this.a180-(this.a90-AOJ)-Math.acos(AH/OA);
			var AAp=Math.cos(BAAp)*AB;
			var ApDp=2*(AAp+Math.sin(AOJ)*OA);
			var y=ApDp;
			var x=(Math.sqrt(Math.pow(BC,2)-Math.pow(ApDp-AAp,2)))+Math.sin(BAAp)*AB;
			//if(angleInitial>0)
			//{
			this.canvas.width=x;
			this.canvas.height=y;
			//}
		}
		else if(angle>0)
		{
			if ((angle>this.a90) && (angle<this.a180)) alpha=this.a180-angle; else alpha=this.a270-angle;
			var AB=this.image.width;
			var OH=this.image.height/2;
			var OA=Math.sqrt(Math.pow(OH,2)+Math.pow(AB/2,2));
			var AOJ=(Math.acos(OH/OA))-alpha;
			var y=2*(OA*Math.cos(AOJ));
			var x=2*(AB*Math.cos(alpha)-OA*Math.sin(AOJ));
			if ((angle>this.a90) && (angle<this.a180))
			{
				this.canvas.width=x;
				this.canvas.height=y;
			}
			else
			{
				this.canvas.width=y;
				this.canvas.height=x;
			}
		}
		//positionnement image
        angle=angleInitial;
        if (angle<0) angle=360+angle;
        angle=this.EnRadian(angle);
        if (angle<=this.a90)
        {
			cx=(2*(this.image.height*Math.sin(angle/2)))*Math.cos(angle/2);
			angleReel=this.EnRadian(angleInitial);
        }
        else if ((angle>this.a90) && (angle<=this.a180))
        {
			angleReel=this.EnRadian(angleInitial);
			angle=angle-this.a90;
			var x=this.image.height;
			cx=x*Math.cos(angle)+this.image.width*Math.cos(this.a90-angle);
			cy=x*Math.sin(angle);
        }
        else if ((angle>this.a180) && (angle<=this.a270))
        {
			var x=this.image.width;
			angleReel=this.EnRadian(angleInitial);
			angle=this.a270-angle;
			cy=this.image.height*Math.sin(angle)+x*Math.cos(angle);
			cx=x*Math.sin(angle);
        }
        else if ((angle>this.a270) && (angle<=this.a360))
        {
			angleReel=this.EnRadian(angleInitial);
			cy=this.image.width*Math.sin(this.a360-angle);
			cx=0;
		}      
		this.canvas.width=(this.canvas.width>=5)?this.canvas.width:5;
		this.canvas.height=(this.canvas.height>=5)?this.canvas.height:5;
		this.cx=cx;
		this.cy=cy;
		this.angleReel=angleReel;
		//context.beginPath();
		this.context.translate(this.cx,this.cy);//dplacement
		this.context.rotate(this.angleReel);//la rotation
		//context.stroke();
	}
	//context.stroke();
	if(!PosX) PosX=0;
	if(!PosY) PosY=0;
	if((PosX+this.image.width>=0 && PosY+this.image.height>=0) || !NSAM6Img.g_DessineStrict)
	{
			this.moveTo(PosX ,PosY);
	}
	else
	{
		return true;
	}
	//pas compris !!!
	//if(NSAM6Img.g_b2Trace)
	//	if(this.x<divGraph.offsetLeft || this.y<divGraph.offsetTop) return true;
	this.context.font=parseInt(this.image.height)+"px Arial";
	this.canvas.width=this.context.measureText(this.txtBouton).width+2*this.image.width;
	
	this.context.drawImage(this.image,0,0,this.image.width,this.image.height);
// Create gradient
var gradient=this.context.createLinearGradient(0,0,this.canvas.width,0);
gradient.addColorStop("0","Maroon");
gradient.addColorStop("0.5","#FF00FF");
gradient.addColorStop("1.0","Maroon");
// Fill with gradient
this.context.fillStyle=gradient;//"Maroon";
	
	this.context.font=parseInt(this.image.height)+"px Arial";
	this.context.fillText(this.txtBouton,this.image.width,this.image.height*0.75);
	
	this.ready=true;
	return true;
	}
	catch(e)
	{
		this.ErrMsg+="Err dessine N "+this.num+" "+angleInitial+"\n";
		this.ErrMsg+=e.message;
		return false;
	}
};
//!Dplacement coordonnes
NSAM6Img.JardinImg.prototype.moveTo=function(x,y)
{
	var dy=0,dx=0,elem;
	var bodyRect = document.getElementById(this.parentId).parentNode.getBoundingClientRect();
	elem=document.getElementById(this.parentId);var rect = elem.getBoundingClientRect();
	dx=rect.left-bodyRect.left;
	dy=rect.top-bodyRect.top;
	if(!this.canvas || this.lock===true || !this.ready)
		return false;
	this.x=parseInt(x);this.y=parseInt(y);
	this.canvas.style.top=(this.y+dy)+"px";
	this.canvas.style.left=(this.x+dx)+"px";
	return true;
//	alert(this.parentId+":"+this.canvas.style.left+","+this.canvas.style.top);
};
//!Dplacement rang colonne
//Visualisation  implmenter
NSAM6Img.JardinImg.prototype.moveToRowCol=function(row,col,newR,newC)
{
	/*for(var pThis=this;pThis;pThis=pThis.pSuiv)
	{
		if(pThis.col==col && pThis.row==row) 
		{
			NSAM6Img.modif=true;
			countModif();
			pThis.col=newC;pThis.row=newR;
			pThis.resize();
		}
	}*/
};

NSAM6Img.JardinImg.prototype.hide=function()
{
	if(!this.canvas) return;
	this.canvas.style.visibility="hidden";
};
NSAM6Img.JardinImg.prototype.show=function()
{
	if(!this.canvas) return;
	this.canvas.style.visibility="visible";
	//this.lock=false;
};

NSAM6Img.JardinImg.prototype.add=function(jaoImg)
{
	var pThis=this,
		n=0;
	while(pThis.pSuiv && ++n<100) pThis=pThis.pSuiv;
	pThis.pSuiv=jaoImg;
	return jaoImg;
};
NSAM6Img.JardinImg.prototype.get=function(numJaoImg)
{
	var pThis=this;
	while(pThis)
	{
		if(pThis.num===numJaoImg) return pThis;
		pThis=pThis.pSuiv;
	}
	return null;
};

NSAM6Img.JardinImg.prototype.getAngle=function() {
	if(!this.mousePos) return -1;
	var Ox=this.canvas.width/2,Oy=this.canvas.height/2;
	var AB=this.mousePos.x-Ox,
		AC=this.mousePos.y-Oy;
	var atg=0;
	if(AB<0) AB*=-1;
	if(AC<0) AC*=-1;
	// Ramener sur le carr inscrit
	if(AB*2>Oy-1) AB=Oy;
	if(AC*2>Ox-1) AC=Ox;
	//============================
	if(AB<Ox/8 && AC<Oy/8) return -1;
	if(AB===0 && AC) atg=0;
	else if(AC===0 && AB) atg=90;
	else atg=this.EnDegre(Math.atan(AB/AC));
	if(this.mousePos.y>=Oy) atg=(180-atg);
	if(this.mousePos.x<Ox) atg=(360-atg);
	return Math.round(atg);	
};
NSAM6Img.JardinImg.prototype.onClick=function(evt)
{this.mousePos=this.getMousePos(this.canvas,evt);};

NSAM6Img.JardinImg.prototype.onDblClick=function(evt) 
{
	this.lock=false;
};
NSAM6Img.JardinImg.prototype.setPlan=function(zOrder,bWithZOrder)
{
	//this.zOrder=(zOrder>0)?zOrder:this.zOrder;
	if(bWithZOrder) this.zOrder=zOrder;
	this.canvas.style.zIndex=zOrder;
};

//!Methode pour attacher une image  une cellule
NSAM6Img.JardinImg.prototype.ToCell=function()
{
	return null;
};
//!Methode pour redimensionner une image sur changement d'chelle du graphe 
NSAM6Img.JardinImg.prototype.resize=function(nSize)
{
	//var nCell,Cell,dx=0,dy=0,size;
	var dx=0,dy=0,size=nSize;
	if(size<=0) return false;
	this.echelleDessin=size/10;//Cell.size/10;
	if(this.isStatic) return;
	
	if(this.row<=0) this.row=1;
	if(this.col<=0) this.col=1;
	
	if(this.echelleDessin===0) this.echelleDessin=1;
	this.x=(((this.col-1)*size)+size/2)-divGraph.scrollLeft;
	this.y=(((this.row-1)*size)+size/2)-divGraph.scrollTop;
	//
	dx=Math.floor(this.dx*this.echelleDessin*this.echelleImg);
	dy=Math.floor(this.dy*this.echelleDessin*this.echelleImg);
	//relativiser
	if(dx)
		dx*=Math.floor((dx/10)/(this.col!=0?this.col:1));
	if(dy)
		dy*=Math.floor((dy/10)/(this.row!=0?this.row:1));
	this.x+=this.dx;this.y+=this.dy;
	this.x-=f_scrollLeft();
	this.y-=f_scrollTop();
	this.dessine(null,null,null,this.x,this.y);
	//this.setPlan(this.plan);
	//alert("resize"+this.imgWidth+" x "+this.imgHeight+" E="+this.echelleImg);
	return true;
};

NSAM6Img.JardinImg.prototype.getMousePos=function(canvas, evt) {
	// get canvas position
	if(!canvas) return null;
	var obj = canvas;
	var top = 0;
	var left = 0;
	while(obj.tagName != 'BODY') {
	  top += obj.offsetTop;
	  left += obj.offsetLeft;
	  obj = obj.offsetParent;
	  if(!obj) break;
	}
	// return relative mouse position
	var mouseCX = evt.clientX;
	var mouseCY = evt.clientY;
	var mousePageX = evt.clientX + window.pageXOffset;
	var mousePageY = evt.clientY + window.pageYOffset;
	var mouseX = evt.clientX - left + window.pageXOffset;
	var mouseY = evt.clientY - top + window.pageYOffset;
	return {
	  x: mouseX,
	  y: mouseY,
	  Px: mousePageX,
	  Py: mousePageY,
	  Cx: mouseCX,
	  Cy: mouseCY
	};
};
//====================================
//!Fournit le 'scroll' gauche
function jao_scrollLeft(mElemtId) {
	var rslt=(jao_filterResults (
		window.pageXOffset ? window.pageXOffset : 0,
		document.documentElement ? document.documentElement.scrollLeft : 0,
		document.body ? document.body.scrollLeft : 0
	)-(mElemtId)?parseInt(document.getElementById(mElemtId).style.left):0);
	return rslt;
}
//!Fournit le 'scroll' haut
function jao_scrollTop(mElemtId) {
	var rslt=(jao_filterResults (
		window.pageYOffset ? window.pageYOffset : 0,
		document.documentElement ? document.documentElement.scrollTop : 0,
		document.body ? document.body.scrollTop : 0
	)-(mElemtId)?parseInt(document.getElementById(mElemtId).style.top):0);
	return rslt;
}
//!Calcul position sur page
function jao_filterResults(n_win, n_docel, n_body) {
	var n_result = n_win ? n_win : 0;
	if (n_docel && (!n_result || (n_result > n_docel)))
		n_result = n_docel;
	return n_body && (!n_result || (n_result > n_body)) ? n_body : n_result;
}
